#include "core/utils/Error.hpp"

CError Core::toString(Error e, char* buffer, size_t size) {
    if(size <= 0) {
        return ErrorCode::CAPACITY_REACHED;
    }
    size_t index = 0;
    Error::Code c = e.code;
    size--;
    while(true) {
        if(index >= size) {
            buffer[index] = '\0';
            return ErrorCode::CAPACITY_REACHED;
        }
        buffer[index++] = (c & 1) ? '1' : '0';
        c >>= 1;
        if(c == 0) {
            break;
        }
    }
    buffer[index] = '\0';
    return ErrorCode::NONE;
}
